Package org.codehaus.groovy.transform

# Class RecordTypeASTTransformation

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.RecordTypeASTTransformation

All Implemented Interfaces:
  `CompilationUnitAware`, `ASTTransformation`, `ErrorCollecting`

public class RecordTypeASTTransformation extends AbstractASTTransformation implements CompilationUnitAware
Handles generation of code for the @RecordType annotation.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final ClassNode`
  `MY_TYPE`

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RecordTypeASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAnnotationName()`
  If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
  `protected GroovyClassLoader`
  `getTransformLoader()`
  `static boolean`
  `recordNative(ClassNode node)`
  Indicates that the given classnode is a native JVM record class.
  `void`
  `setCompilationUnit(CompilationUnit unit)`
  Sets the compilation unit currently applying this transformation.
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.
  `static boolean`
  `wouldBeNativeRecord(ClassNode cNode, String targetBytecode)`
  Predicts whether `cNode` will be compiled as a native JVM record.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### MY_TYPE

    public static final ClassNode MY_TYPE

- ## Constructor Details

  - ### RecordTypeASTTransformation

    public RecordTypeASTTransformation()

- ## Method Details

  - ### getAnnotationName

    public String getAnnotationName()
    Description copied from class: `AbstractASTTransformation`
    If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
    Overrides:
      `getAnnotationName` in class `AbstractASTTransformation`
    Returns:
      The simple name of the annotation including the "@" or null if no such name is defined

  - ### setCompilationUnit

    public void setCompilationUnit(CompilationUnit unit)
    Description copied from interface: `CompilationUnitAware`
    Sets the compilation unit currently applying this transformation.
    Specified by:
      `setCompilationUnit` in interface `CompilationUnitAware`
    Parameters:
      `unit` - the active compilation unit

  - ### getTransformLoader

    protected GroovyClassLoader getTransformLoader()

  - ### recordNative

    @Incubating public static boolean recordNative(ClassNode node)
    Indicates that the given classnode is a native JVM record class. For classes being compiled, this will only be valid after the `RecordTypeASTTransformation` transform has been invoked.

  - ### wouldBeNativeRecord

    @Incubating public static boolean wouldBeNativeRecord(ClassNode cNode, String targetBytecode)
    Predicts whether `cNode` will be compiled as a native JVM record. Mirrors the decision logic in `doProcessRecordType(org.codehaus.groovy.ast.ClassNode, groovy.transform.options.PropertyHandler)` (presence of `@RecordBase`, target bytecode `>= 17`, and `@RecordOptions(mode != EMULATE)`) so callers running before the transform itself fires can act on the same outcome.

    The joint-compilation stub generator uses this at `Phases.CONVERSION` to decide whether to emit `record Foo(...)` syntax. Unlike `recordNative(ClassNode)`, which inspects the post-transform super class, this predicate inspects only the source-level annotations.

    Parameters:
      `cNode` - the candidate class node
      `targetBytecode` - the target bytecode level (see `CompilerConfiguration.getTargetBytecode()`)
    Since:
      6.0.0

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.